﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections;

namespace WpfApplication110
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Person> people = new ObservableCollection<Person>();
        Hashtable uniquekeys = new Hashtable();
        
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            Person p = new Person(uniquekeys,  1,  "matt", "programmer" );
            Person q = new Person(uniquekeys,  2,  "joe",   "cop" );
            Person v = new Person(uniquekeys,  3,  "dave",  "rancher" );
            Person w = new Person(uniquekeys,  4,  "phil",  "teacher" );

            people.Add(p);
            people.Add(q);
            people.Add(v);
            people.Add(w);

       //     UpdateUniqueKeys();

            xgrid.DataSource = people;
            xgrid.FieldSettings.AllowEdit = true;
            xgrid.EditModeEnding += new EventHandler<Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs>(xgrid_EditModeEnding);
            xgrid.CellUpdating += new EventHandler<Infragistics.Windows.DataPresenter.Events.CellUpdatingEventArgs>(xgrid_CellUpdating);
            xgrid.DataError += new EventHandler<Infragistics.Windows.DataPresenter.Events.DataErrorEventArgs>(xgrid_DataError);
        }

        void xgrid_DataError(object sender, Infragistics.Windows.DataPresenter.Events.DataErrorEventArgs e)
        {
            //row new NotImplementedException();
            e.Handled = true;
            MessageBox.Show("this id is not unique");
        }

        void xgrid_CellUpdating(object sender, Infragistics.Windows.DataPresenter.Events.CellUpdatingEventArgs e)
        {
            
            //throw new NotImplementedException();
            //if (e.Cell.Field.Name == "ID")
            //{
            //    if (uniquekeys.ContainsKey(e.Cell.Value))
            //    {
            //        string mes = "this key belongs or did belong to " + uniquekeys[e.Cell.Value].ToString();
            //        MessageBox.Show(mes);

            //    }
            //    else uniquekeys.Add(e.Cell.Value, e.Record.Cells["Name"].Value);
            //}
            
        }

        void xgrid_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {
           // throw new NotImplementedException();
            if (e.Cell.Field.Name == "ID")
            {
             
            }
        }

        private void UpdateUniqueKeys()
        {
            foreach (Person p in people)
            {
                uniquekeys.Add(p.ID, p.Name);
            }
        }
    }
}
